long InitDirectInput(HWND,HINSTANCE);
long ReleaseDirectInput(void);
long GetKeyDown(BYTE);
long GetKeyUp(BYTE);
WORD ReadKeys(WORD);
WORD ReadButtons(WORD);
void UpdateKeys(void);
long InitMouse(HWND);
long ReleaseMouse(void);
bool CheckAnyButtonDown(DWORD*);
bool CheckButtonDown(DWORD);
void GetNameForKeycode(DWORD,char*);

typedef struct {
	int button[21];
} JOYPAD;

typedef struct {
	int min;
	int max;
	int center;
	int threshold;
} JOYSTICK_AXIS;

#ifndef __PORT__
typedef struct {
	char name[100];
	JOYSTICK_AXIS axis[6];
	LPDIRECTINPUTDEVICE8 Device;
	DIJOYSTATE2 State;
	DIDEVCAPS Caps;
} JOYSTICK_INFO;
#endif

enum JOYPAD_BUTTONS {
	BUTTON_A,
	BUTTON_B,
	BUTTON_C,
	BUTTON_UP,
	BUTTON_DOWN,
	BUTTON_LEFT,
	BUTTON_RIGHT,
	BUTTON_PAUSE,
	BUTTON_OPTION,
	BUTTON_0,
	BUTTON_1,
	BUTTON_2,
	BUTTON_3,
	BUTTON_4,
	BUTTON_5,
	BUTTON_6,
	BUTTON_7,
	BUTTON_8,
	BUTTON_9,
	BUTTON_ASTERISK,
	BUTTON_SHARP
};

/*const JOYPAD default_keys =
{ 0x100001E, 0x100001F, 0x1000020, 0x10000C8, 0x10000D0, 0x10000CB, 0x10000CD,
  0x1000019, 0x1000018, 0x1000052, 0x100004F, 0x1000050, 0x1000051, 0x100004B,
  0x100004C, 0x100004D, 0x1000047, 0x1000048, 0x1000049, 0x1000037, 0x10000B5 };

const JOYPAD default_joypad =
{ 0x000F00, 0x000F01, 0x000F02, 0x0001FF, 0x000100, 0x0000FF, 0x000000,
  0x000F03, 0x000F04, 0x1000052, 0x100004F, 0x1000050, 0x1000051, 0x100004B,
  0x100004C, 0x100004D, 0x1000047, 0x1000048, 0x1000049, 0x000F05, 0x000F06 };*/

const char keynames[256][16] = 
{ /*00*/ "?","Escape","1","2","3","4","5","6","7","8","9","0","-","=","Backspace","Tab",
  /*10*/ "Q","W","E","R","T","Y","U","I","O","P","[","]","Return","Left Control","A","S",
  /*20*/ "D","F","G","H","J","K","L",";",":","'","Left Shift","\\","Z","X","C","V",
  /*30*/ "B","N","M",",",".","/","Right Shift","Numpad *","Left Alt","Space","Caps Lock","F1","F2","F3","F4","F5",
  /*40*/ "F6","F7","F8","F9","F10","Num Lock","Scroll Lock","Numpad 7","Numpad 8","Numpad 9","Numpad -","Numpad 4","Numpad 5","Numpad 6","Numpad +","Numpad 1",
  /*50*/ "Numpad 2","Numpad 3","Numpad 0","Numpad .","?","?","?","F11","F12","?","?","?","?","?","?","?",
  /*60*/ "?","?","?","?","F13","F14","F15","?","?","?","?","?","?","?","?","?",
  /*70*/ "?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?",
  /*80*/ "?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?",
  /*90*/ "Prev. Track","?","?","?","?","?","?","?","?","Next Track","?","?","Numpad Enter","Right Control","?","?",
  /*A0*/ "Mute","Calculator","Play / Pause","?","Media Stop","?","?","?","?","?","?","?","?","?","Volume -","?",
  /*B0*/ "Volume +","?","Web Home","Numpad ,","?","Numpad /","?","?","Right Alt","?","?","?","?","?","?","?",
  /*C0*/ "?","?","?","?","?","Pause","?","Home","Up Arrow","Page Up","?","Left Arrow","?","Right Arrow","?","End",
  /*D0*/ "Down Arrow","Page Down","Insert","Delete","?","?","?","?","?","?","?","Left Windows","Right Windows","AppMenu","System Power","System Sleep",
  /*E0*/ "?","?","?","System Wake","?","Web Search","Web Favorites","Web Refresh","Web Stop","Web Forward","Web Back","My Computer","Mail","Media Select","?","?",
  /*F0*/ "?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?"
  };